unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls, Menus;
const
  Mapa:array[0..2,0..2]of byte=
                         ((10,10,10),
                          (16,16,40),
                          (30,16,99)
                         );
  kierunek:array[0..7,0..1] of ShortInt= ((-1,-1),(0,-1),( 1,-1),
                                          (-1, 0),       ( 1, 0),
                                          (-1, 1),(0, 1),( 1, 1));

type
  tPoziom=(tPoczatkujacy,tSredni,tEkspert);
  tStanPola=(tObojetne,tMina,tNiepewne);
  tKafel=record
         zaminowane:boolean;
         sprawdzone:boolean;
         StanPola:tStanPola;
  end;
  TPlansza=class(TImage)
    bmp:tBitmap;
  private
    fPoziom:tPoziom;
    KafelW,
    KafelH:byte;//rozmira pola
    PoleMinowe:array of array of tKafel;
    destructor Destroy; override;
    constructor Create(AOwner:TComponent;
                       AParent:TWinControl;
                       ALeft,ATop:integer;
                       ABMP:TBitmap;
                       AColor:TColor);virtual;
    procedure  MouseDown(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    procedure  MouseUp(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    procedure  TworzPoleMinowe;
    procedure  OdkryjPustePola(aK,aW,n:integer);
    procedure  PokazMiny;
    procedure  Buzka(aK,aW:integer;AImage:TImage);
    function   IleMinSasiednich(aK,aW:integer):byte;
   public
    fKoniecGry,
    fStart:boolean;
    czas  :integer;
    fZnalezionaMina:integer;
    procedure  RysujPlansze(APoziom:tPoziom);//rysuje czysta plansza gry

  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Gra1: TMenuItem;
    Oprogramie1: TMenuItem;
    Nowa1: TMenuItem;
    N1: TMenuItem;
    Koniec1: TMenuItem;
    Panel1: TPanel;
    Pocztkujacy1: TMenuItem;
    redniozaawansowany1: TMenuItem;
    Ekspert1: TMenuItem;
    Timer1: TTimer;
    cyfry: TImage;
    Image1: TImage;
    zasobnik: TImage;
    Image2: TImage;
    Buzka: TImage;
    Image4: TImage;
    Inormacje1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Pocztkujacy1Click(Sender: TObject);
    procedure redniozaawansowany1Click(Sender: TObject);
    procedure Ekspert1Click(Sender: TObject);
    procedure Koniec1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Nowa1Click(Sender: TObject);
    procedure Inormacje1Click(Sender: TObject);
  private
    { Private declarations }
    procedure Licznik(aWartosc,dlugosc:integer;ACanvas:TCanvas);
    procedure ZerowanieLicznikow;
  public
    { Public declarations }

  end;

var
  Form1: TForm1;
  fPoziom:tPoziom;
  Plansza:TPlansza;
implementation

uses Unit2;

{$R *.DFM}
function   TPlansza.IleMinSasiednich(aK,aW:integer):byte;
var
 i:integer;
begin
 result:=0;
 for i:=0 to high(Kierunek)do
  begin
     if (kierunek[i,1]+aW<0)or(kierunek[i,1]+aW>Mapa[ord(tPoziom(fPoziom)),1]) then continue;
     if (kierunek[i,0]+aK<0)or(kierunek[i,0]+aK>Mapa[ord(tPoziom(fPoziom)),0]) then continue;
     if PoleMinowe[kierunek[i,1]+aW,kierunek[i,0]+aK].zaminowane then
     inc(result);
  end;
  case result of
   1:Canvas.Font.Color:=clBlue;
   2:Canvas.Font.Color:=clGreen;
   3:Canvas.Font.Color:=clRed;
   4:Canvas.Font.Color:=clAqua;
   5:Canvas.Font.Color:=clMaroon;
   6:Canvas.Font.Color:=clLime;
   7:Canvas.Font.Color:=clYellow;
   8:Canvas.Font.Color:=clFuchsia;
  end;
end;
procedure TPlansza.Buzka(aK,aW:integer;AImage:TImage);
begin
 if not (PoleMinowe[aW,aK].zaminowane) then
 BitBlt(AImage.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,0,0,srcCopy);
 if (PoleMinowe[aW,aK].zaminowane) then
 BitBlt(AImage.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,34,0,srcCopy);
 if (PoleMinowe[aW,aK].StanPola=tMina) then
 BitBlt(AImage.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,0,0,srcCopy);
 if fKoniecGry then
 BitBlt(AImage.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,34,0,srcCopy);
 AImage.Repaint;
end;
procedure  TPlansza.PokazMiny;
var
 k,w,
 i,j:integer;
begin
  fStart:=false;
  for j:=0 to Mapa[ord(tPoziom(fPoziom)),1] do
   for i:=0 to Mapa[ord(tPoziom(fPoziom)),0] do
   if  (PoleMinowe[j,i].zaminowane)or(PoleMinowe[j,i].StanPola=tMina)
    //and(not PoleMinowe[j,i].sprawdzone)
    then
    begin
     if PoleMinowe[j,i].StanPola<>tMina then
     BitBlt(Picture.Bitmap.Canvas.Handle,i*KafelW,j*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,32,0,srcCopy)
     else
      if(PoleMinowe[j,i].StanPola=tMina)and(not PoleMinowe[j,i].zaminowane)then
      BitBlt(Picture.Bitmap.Canvas.Handle,i*KafelW,j*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,64,0,srcCopy)
    end;
end;
procedure  TPlansza.OdkryjPustePola(aK,aW,n:integer);
var
 ile,
 k,w,k1,w1,ileM,
 i,j:integer;
begin
 if n>Mapa[ord(tPoziom(fPoziom)),0]*Mapa[ord(tPoziom(fPoziom)),1]+1 then exit;
 for i:=0 to high(Kierunek)do
  begin
     k:=kierunek[i,0]+aK;
     w:=kierunek[i,1]+aW;
     if (w<0)or(W>Mapa[ord(tPoziom(fPoziom)),1]) then continue;
     if (k<0)or(K>Mapa[ord(tPoziom(fPoziom)),0]) then continue;
     if (not PoleMinowe[W,K].zaminowane)
     and(not PoleMinowe[W,K].sprawdzone)
     and(IleMinSasiednich(K,W)=0)
     and(PoleMinowe[W,K].StanPola<>tmina)
      then
     begin
        ileM:=IleMinSasiednich(K,W);
        PoleMinowe[W,K].sprawdzone:=true;
        BitBlt(Picture.Bitmap.Canvas.Handle,K*KafelW,W*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,16,0,srcCopy);
        //sprawdz ssiadw
        for j:=0 to high(Kierunek)do begin
          k1:=kierunek[j,0]+K;
          w1:=kierunek[j,1]+W;
          if (w1<0)or(W1>Mapa[ord(tPoziom(fPoziom)),1]) then continue;
          if (k1<0)or(K1>Mapa[ord(tPoziom(fPoziom)),0]) then continue;
          if (not PoleMinowe[W1,K1].zaminowane)
          and(IleMinSasiednich(K1,W1)>0)
          and(PoleMinowe[W1,K1].StanPola<>tmina)
          then begin
           ileM:=IleMinSasiednich(K1,W1);
           BitBlt(Picture.Bitmap.Canvas.Handle,K1*KafelW,W1*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,16,0,srcCopy);
           if ileM>0 then Picture.Bitmap.Canvas.TextOut(K1*KafelW,W1*KafelH,IntToStr(ileM));
          end;
        end;
        OdkryjPustePola(K,W,n+1);
     end;
  end;
end;

procedure  TPlansza.TworzPoleMinowe;
var
  wylosowano,
  k,w,i,j:integer;
begin
  fStart:=false;
  Czas:=0;
  fZnalezionaMina:=0;
  //usmiechnieta buzka
  BitBlt(Form1.Image4.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,0,0,srcCopy);
  Form1.Image4.Repaint;
  k:=Mapa[ord(tPoziom(fPoziom)),0];
  w:=Mapa[ord(tPoziom(fPoziom)),1];
  PoleMinowe:=nil;
  setLength(PoleMinowe,w+1,k+1);
  for j:=0 to w do
   for i:=0 to k do begin
     PoleMinowe[j,i].zaminowane:=false;
     PoleMinowe[j,i].sprawdzone:=false;
     PoleMinowe[j,i].StanPola:=tObojetne;
   end;
  //losuj miny
  wylosowano:=0;
  while wylosowano<Mapa[ord(tPoziom(fPoziom)),2]do begin
     k:=Random(Mapa[ord(tPoziom(fPoziom)),0]);
     w:=Random(Mapa[ord(tPoziom(fPoziom)),1]);
     if not PoleMinowe[w,k].zaminowane then begin
        inc(wylosowano);
        PoleMinowe[w,k].zaminowane:=true;
     end;
  end;
end;
procedure  TPlansza.RysujPlansze(APoziom:tPoziom);
var
  k,w,i,j:integer;
begin
 fPoziom:=APoziom;
 k:=Mapa[ord(tPoziom(fPoziom)),0];
 w:=Mapa[ord(tPoziom(fPoziom)),1];

 width :=k*KafelW;
 height:=w*KafelH;

 Picture.Bitmap.Width:=width;
 Picture.Bitmap.Height:=height;

 for j:=0 to w do
 for i:=0 to k do
 BitBlt(Picture.Bitmap.Canvas.Handle,i*KafelW,j*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,0,0,srcCopy);
 Repaint;

 TworzPoleMinowe;
end;
procedure  TPlansza.MouseUp(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
var
  k,w:integer;
begin
  k:=x div KafelW;
  w:=y div KafelH;
  Buzka(K,W,Form1.Image4);
end;

procedure  TPlansza.MouseDown(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
var
  k,w:integer;
begin
  if fKoniecGry then exit;
  fStart:=true;
  Form1.Timer1.Enabled:=fStart;
  //
  k:=x div KafelW;
  w:=y div KafelH;
  if Button=mbLeft then
  begin
   if (not PoleMinowe[w,k].sprawdzone)
    and(PoleMinowe[w,k].StanPola<>tmina)
     then begin
     //rysuj niepewna buzke
     BitBlt(Form1.Image4.Canvas.Handle,0,0,17,17,Form1.Buzka.Picture.Bitmap.Canvas.handle,17,0,srcCopy);
     Form1.Image4.Repaint;
     //trafino w puste pole
     if not PoleMinowe[w,k].zaminowane then
     begin
      BitBlt(Picture.Bitmap.Canvas.Handle,k*KafelW,w*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,16,0,srcCopy);
      if IleMinSasiednich(K,W)>0 then Picture.Bitmap.Canvas.TextOut(k*KafelW,w*KafelH,IntToStr(IleMinSasiednich(K,W)));
      OdkryjPustePola(K,W,0);
      PoleMinowe[w,k].sprawdzone:=true;
     end
     else
     //trafiono w mine
     begin
     PoleMinowe[w,k].sprawdzone:=true;
     fKoniecGry:=true;
     BitBlt(Picture.Bitmap.Canvas.Handle,k*KafelW,w*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,48,0,srcCopy);
     PokazMiny;
     end;
     Repaint;
   end;
  end;//koniec dla LPM
  if Button=mbRight then begin
     case PoleMinowe[w,k].StanPola of
      tObojetne:begin
                 PoleMinowe[w,k].StanPola:=tMina;
                 inc(fZnalezionaMina);
                 if fZnalezionaMina>Mapa[ord(tPoziom(fPoziom)),2] then
                    fZnalezionaMina:=Mapa[ord(tPoziom(fPoziom)),2];
                 Form1.Licznik(Mapa[ord(tPoziom(fPoziom)),2]-fZnalezionaMina,3,Form1.Image1.Canvas);
                 Form1.Image1.Repaint;
                 BitBlt(Picture.Bitmap.Canvas.Handle,k*KafelW,w*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,80,0,srcCopy);
                 Repaint;
                 exit;
                end;
      tMina    :begin
                 PoleMinowe[w,k].StanPola:=tNiepewne;
                 dec(fZnalezionaMina);
                 if fZnalezionaMina<0 then
                    fZnalezionaMina:=0;
                 Form1.Licznik(Mapa[ord(tPoziom(fPoziom)),2]-fZnalezionaMina,3,Form1.Image1.Canvas);
                 Form1.Image1.Repaint;
                 BitBlt(Picture.Bitmap.Canvas.Handle,k*KafelW,w*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,96,0,srcCopy);
                 Repaint;
                 exit;
                end;
      tNiepewne:begin
                 PoleMinowe[w,k].StanPola:=tObojetne;
                 BitBlt(Picture.Bitmap.Canvas.Handle,k*KafelW,w*KafelH,KafelW,KAfelH,BMP.Canvas.Handle,0,0,srcCopy);
                 PoleMinowe[w,k].sprawdzone:=false;
                 Repaint;
                 exit;
                end;
     end;
  end;
end;

destructor TPlansza.Destroy;
begin
  bmp.free;
  inherited;
end;
constructor TPlansza.Create(AOwner:TComponent;AParent:TWinControl;
                       ALeft,ATop:integer;
                       ABMP:TBitmap;
                       AColor:TColor);
begin
  inherited Create(AOwner);
  fKoniecGry:=false;
  KafelW:=16;
  KafelH:=16;
  left:=ALeft;
  top :=ATop;
  with Canvas do begin
       brush.style:=bsSolid;
       brush.Color:=AColor;
       fillRect(ClipRect);
       Font.Style:=[fsBold];
  end;
  Parent:=AParent;
  OnMouseDown:=MouseDown;
  OnMouseUp  :=MouseUp;
  bmp:=TBitmap.Create;
  bmp.width:=ABMP.width;
  bmp.Height:=ABmp.Height;
  bmp.Canvas.Draw(0,0,ABMP);

end;
//********************************************
procedure TForm1.Licznik(aWartosc,dlugosc:integer;ACanvas:TCanvas);
const
 skok=14;
var
 c,
 i:integer;
 s:string;
begin
 //z liczby zrb sowo
 s:=IntToStr(aWartosc);
 //uzupenij zerami zgodnie z iloscia miejsc na wyswietlaczu zgara gry
 if Length(s)<dlugosc then for i:=1 to dlugosc-Length(s) do s:='0'+s;
 for i:=1 to Length(s) do begin
     c:=StrToInt(s[i]);
     //wytnij obrazy cyfr zegara gry
     BitBlt(ACanvas.handle,(i-1)*skok,0,skok,19,cyfry.canvas.handle,c*skok,0,srcCopy);

 end;
 ACanvas.Refresh;
end;
procedure TForm1.ZerowanieLicznikow;
begin
 //
 Image1.width:=42;
 Licznik(Mapa[ord(tPoziom(fPoziom)),2],3,Image1.Canvas);
 Image1.Repaint;
 //czasomierz
 Licznik(Plansza.Czas,4,Image2.Canvas);
 Image2.Repaint;
end;
procedure TForm1.FormCreate(Sender: TObject);
var
 width,height:integer;
begin
 Randomize;
 fPoziom:=tPoczatkujacy;
 width :=Mapa[ord(tPoziom(fPoziom)),0]*16;
 height:=Mapa[ord(tPoziom(fPoziom)),1]*16;
 Form1.ClientWidth:=width;
 Form1.ClientHeight:=height+Panel1.Height;
 Plansza:=TPlansza.Create(Form1,Form1,0,Panel1.Height,Zasobnik.Picture.Bitmap,clSilver);
 Plansza.RysujPlansze(fPoziom);
 ZerowanieLicznikow;
end;

procedure TForm1.Pocztkujacy1Click(Sender: TObject);
begin
 fPoziom:=tPoczatkujacy;
 Pocztkujacy1.Checked:=true;
 redniozaawansowany1.Checked:=false;
 Ekspert1.checked:=false;
 Plansza.fKoniecGry:=false;
 Plansza.RysujPlansze(fPoziom);
 Form1.ClientWidth :=Mapa[ord(tPoziom(fPoziom)),0]*16;
 Form1.ClientHeight:=Mapa[ord(tPoziom(fPoziom)),1]*16+Panel1.Height;
 ZerowanieLicznikow;
end;

procedure TForm1.redniozaawansowany1Click(Sender: TObject);
begin
 fPoziom:=tSredni;
 Pocztkujacy1.Checked:=false;
 redniozaawansowany1.Checked:=true;
 Ekspert1.checked:=false;
 Plansza.fKoniecGry:=false;
 Plansza.RysujPlansze(fPoziom);
 Form1.ClientWidth :=Mapa[ord(tPoziom(fPoziom)),0]*16;
 Form1.ClientHeight:=Mapa[ord(tPoziom(fPoziom)),1]*16+Panel1.Height;
 ZerowanieLicznikow;
end;

procedure TForm1.Ekspert1Click(Sender: TObject);
begin
 fPoziom:=tEkspert;
 Pocztkujacy1.Checked:=false;
 redniozaawansowany1.Checked:=false;
 Ekspert1.checked:=true;
 Plansza.fKoniecGry:=false;
 Plansza.RysujPlansze(fPoziom);
 Form1.ClientWidth :=Mapa[ord(tPoziom(fPoziom)),0]*16;
 Form1.ClientHeight:=Mapa[ord(tPoziom(fPoziom)),1]*16+Panel1.Height;
 ZerowanieLicznikow;
end;

procedure TForm1.Koniec1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Plansza.Destroy;
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
  Image2.left:=Panel1.ClientWidth-Image2.width-4;
  Image4.Left:=(Panel1.ClientWidth-Image4.width)div 2- Image4.width div 2;
end;

procedure TForm1.Timer1Timer(Sender: TObject);

begin
 if not Plansza.fStart then Timer1.Enabled:=false;
 inc(Plansza.Czas);
 Licznik(Plansza.Czas,4,Image2.Canvas);
 Image2.Repaint;
end;

procedure TForm1.Nowa1Click(Sender: TObject);
begin
 Plansza.fKoniecGry:=false;
 Plansza.RysujPlansze(fPoziom);
 Form1.ClientWidth :=Mapa[ord(tPoziom(fPoziom)),0]*16;
 Form1.ClientHeight:=Mapa[ord(tPoziom(fPoziom)),1]*16+Panel1.Height;
 ZerowanieLicznikow;
end;

procedure TForm1.Inormacje1Click(Sender: TObject);
begin
 AboutBox.ShowModal;
end;

end.
